unit PlotPanelDemoUnit;
 {
 *  Demonstration program for my PlotPanel component
 *
 *  Copyright (C) 2001  Marien van Westen
 *
 *  You are free to use and modify this code under the terms of
 *  the GNU General Public Licence version 2 or later.
 *
 }

interface

uses
  SysUtils, Types, Classes, Variants, QGraphics, QControls, QForms, QDialogs,
  QExtCtrls, QStdCtrls, QComCtrls, PlotPanel, QTypes;

type
  TForm1 = class(TForm)
    PageControl1: TPageControl;
    SimplePlot: TTabSheet;
    Advanced: TTabSheet;
    TimerPlot: TTabSheet;
    PlotMode: TRadioGroup;
    Parabool: TButton;
    Sinus: TButton;
    Lissajous: TButton;
    Sinus2: TButton;
    Plotmode1: TRadioGroup;
    Parabool2: TButton;
    Start: TButton;
    Stop: TButton;
    Timer1: TTimer;
    Panel1: TPanel;
    Label1: TLabel;
    PenWidth: TSpinEdit;
    btClear: TButton;
    btShowMarks: TButton;
    btAxisColor: TButton;
    btBackColor: TButton;
    btAutoScale: TButton;
    Title: TButton;
    ColorDialog1: TColorDialog;
    HideRed: TButton;
    HideGreen: TButton;
    XLabel: TLabel;
    YLabel: TLabel;
    TestLabel: TLabel;
    PlotPanel1: TPlotPanel;
    ZoomIn: TButton;
    ZoomOut: TButton;
    procedure Parabool2Click(Sender: TObject);
    procedure SinusClick(Sender: TObject);
    procedure btClearClick(Sender: TObject);
    procedure ParaboolClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Sinus2Click(Sender: TObject);
    procedure PlotModeClick(Sender: TObject);
    procedure PenWidthClick(Sender: TObject);
    procedure btAutoScaleClick(Sender: TObject);
    procedure btShowMarksClick(Sender: TObject);
    procedure btAxisColorClick(Sender: TObject);
    procedure btBackColorClick(Sender: TObject);
    procedure LissajousClick(Sender: TObject);
    procedure TitleClick(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure StartClick(Sender: TObject);
    procedure StopClick(Sender: TObject);
    procedure PageControl1Change(Sender: TObject);
    procedure Plotmode1Click(Sender: TObject);
    procedure HideRedClick(Sender: TObject);
    procedure HideGreenClick(Sender: TObject);
    procedure PlotPanel1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure FormMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure ZoomInClick(Sender: TObject);
    procedure ZoomOutClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  PanelWidth, PanelHeight : Integer;
  But : Integer;

implementation

{$R *.xfm}

procedure TForm1.Parabool2Click(Sender: TObject);
var
  i : Integer;
begin

   PlotPanel1.Xmin:=-8;
   PlotPanel1.Xmax:=12;
   PlotPanel1.Ymin:=-20;
   PlotPanel1.Ymax:=80;
   PlotPanel1.XMarksInterval:=2;
   PlotPanel1.YMarksInterval:=10;
   PlotPanel1.Clear;
 for i:= -10 to +10 do
   begin
   PlotPanel1.AddXY(i, i*i,clRed,0);
   PlotPanel1.AddXY(i, i*i+i*2,clLime,1);
   end;
end;

procedure TForm1.SinusClick(Sender: TObject);
var i:Integer;
    y:Real;
begin

   PlotPanel1.Xmin:=0;
   PlotPanel1.Xmax:=50;
   PlotPanel1.Ymin:=-40;
   PlotPanel1.Ymax:=40;
   PlotPanel1.XMarksInterval:=5;
   PlotPanel1.YMarksInterval:=5;
   PlotPanel1.Clear;
   for i:=0 to 50 do
     begin
       y:=30 * sin(2*PI*i/50);
       PlotPanel1.AddXY(i,y,clRed,0);
     end;
end;

procedure TForm1.btClearClick(Sender: TObject);
begin

   PlotPanel1.Xmin:=0;
   PlotPanel1.Xmax:=10;
   PlotPanel1.Ymin:=0;
   PlotPanel1.Ymax:=10;
   PlotPanel1.XMarksInterval:=1;
   PlotPanel1.YMarksInterval:=1;
   PlotPanel1.Clear;
end;

procedure TForm1.ParaboolClick(Sender: TObject);
var
  i : Integer;
begin

   PlotPanel1.Xmin:=-10;
   PlotPanel1.Xmax:=10;
   PlotPanel1.Ymin:=0;
   PlotPanel1.Ymax:=100;
   PlotPanel1.XMarksInterval:=2;
   PlotPanel1.YMarksInterval:=10;
   PlotPanel1.Clear;
   PlotPanel1.PlotPen.Color:=clRed;
 for i:= -10 to +10 do
   PlotPanel1.AddXY(i, i*i);
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
 PanelWidth:=PlotPanel1.Width;
 PanelHeight:=PlotPanel1.Height;
 PenWidth.Value:= PlotPanel1.PlotPen.Width;
end;


procedure TForm1.Sinus2Click(Sender: TObject);
var
   i : Integer;
   y: Real;
begin
   But:=5 ;
   PlotPanel1.Clear;
   PlotPanel1.Xmin:=10;
   PlotPanel1.Xmax:=55;
   PlotPanel1.Ymin:=-30;
   PlotPanel1.Ymax:=40;
   PlotPanel1.XMarksInterval:=5;
   PlotPanel1.YMarksInterval:=5;
   PlotPanel1.Clear;
   for i:=0 to 50 do
     begin
       y:=30 * sin(2*PI*i/50);
       PlotPanel1.AddXY(i,y,clRed,0);
       PlotPanel1.AddXY(i,-0.5*y,clLime,1);
     end;

end;

procedure TForm1.PlotModeClick(Sender: TObject);
begin
   if PlotMode.ItemIndex=0 then PlotPanel1.PlotMode:=pmDot;
   if PlotMode.ItemIndex=1 then PlotPanel1.PlotMode:=pmLine;
   if PlotMode.ItemIndex=2 then PlotPanel1.PlotMode:=pmBar;
end;

procedure TForm1.PenWidthClick(Sender: TObject);
begin
  PlotPanel1.PlotPen.Width:=PenWidth.Value;

end;

procedure TForm1.btAutoScaleClick(Sender: TObject);
begin
 PlotPanel1.AutoScale(0);
end;

procedure TForm1.btShowMarksClick(Sender: TObject);
begin
   if btShowMarks.Tag=0 then
      begin
         PlotPanel1.XMarks:=True;
         PlotPanel1.YMarks:=True;
         btShowMarks.Tag:=1;
      end
      else
      begin
         PlotPanel1.XMarks:=False;
         PlotPanel1.YMarks:=False;
         btShowMarks.Tag:=0;
      end;
end;

procedure TForm1.btAxisColorClick(Sender: TObject);
begin
 ColorDialog1.Color:=PlotPanel1.GridColor;
 if ColorDialog1.Execute then PlotPanel1.GridColor := ColorDialog1.Color;
end;

procedure TForm1.btBackColorClick(Sender: TObject);
begin
  ColorDialog1.Color:=PlotPanel1.BackColor;
 if ColorDialog1.Execute then PlotPanel1.BackColor := ColorDialog1.Color;
end;

procedure TForm1.LissajousClick(Sender: TObject);
var t:Integer;
     rd,kx1,ky1,py,fx1,fy1:Real;
begin
   rd:= Pi/360;
   fx1:=2;
   fy1:=3;
   py:=10;
   kx1:=7.0;
   ky1:=6.2;
   PlotPanel1.Clear;
   PlotPanel1.Freeze(true);
      for t:=0 to 720 do
      begin
         PlotPanel1.AddXY(kx1*sin(fx1*t*rd),ky1*sin(fy1*t*rd+py*rd*2),clblue,0);

      end;
   PlotPanel1.Freeze(False);
end;

procedure TForm1.TitleClick(Sender: TObject);
begin
 PlotPanel1.Title:=Inputbox('PlotPanel Test','What is the Title', 'PlotPanel');
 if Length(PlotPanel1.Title)<2 then PlotPanel1.Title:='';
end;

procedure TForm1.Timer1Timer(Sender: TObject);
var
   i :Integer;
   y,u : Double;
begin

  u:=30*sin(2*PI*Start.Tag/60);
  Start.Tag:=Start.Tag+1;
  if Start.Tag >=60 then Start.Tag:=0;

  PlotPanel1.Freeze(true);
  PlotPanel1.Clear;

    PlotPanel1.AddXY(0,0,clRed,1);
    for i:=1 to 60 do
    begin
      y:=u*sin(2*Pi*i/21.6);
      PlotPanel1.AddXY(i,y,clRed,1);
    end;

    PlotPanel1.AddXY(0,0,clBlue,2);
    for i:=1 to 60 do
    begin
      y:=u*sin(2*Pi*i/21.6);
      PlotPanel1.AddXY(i,y,clBlue,2);
    end;

    PlotPanel1.Freeze(false);

end;

procedure TForm1.StartClick(Sender: TObject);
begin
  With PlotPanel1 do
  begin
  XMax:=60;
  XMin:=0;
  YMax:=30;
  YMin:=-30;
  Color:=clBlack;
  BackColor:=clBlack;
  GridColor:=clOlive;
  XMarksFont.Color:=clWhite;
  XMarksInterval:=6;
  YMarksInterval:=6;
  YMarks:=False;
  XMarks:=True;
  Title:='';
  LayerOptions(2,pmDot,10);
  LayerOptions(1,pmLine,1);
  end;
  Timer1.Enabled:=True;
end;

procedure TForm1.StopClick(Sender: TObject);
begin
 Timer1.Enabled:=False;
end;

procedure TForm1.PageControl1Change(Sender: TObject);
begin
  Timer1.Enabled:=False;

  With PlotPanel1 do
  begin
  XMax:=10;
  XMin:=0;
  YMax:=10;
  YMin:=00;
  Color:=clButton;
  BackColor:=clWhite;
  GridColor:=clBlack;
  XMarksFont.Color:=clBlack;
  XMarksInterval:=1;
  YMarksInterval:=1;
  YMarks:=False;
  XMarks:=False;
  Title:='';
  LayerOption:=False;
  PlotPen.Width:=2;
  PlotMode:=pmLine;
  Clear;
  PenWidth.Value:=2;
  end;

end;

procedure TForm1.Plotmode1Click(Sender: TObject);
begin
   if PlotMode1.ItemIndex=0 then PlotPanel1.PlotMode:=pmDot;
   if PlotMode1.ItemIndex=1 then PlotPanel1.PlotMode:=pmLine;
   if PlotMode1.ItemIndex=2 then PlotPanel1.PlotMode:=pmBar;
end;

procedure TForm1.HideRedClick(Sender: TObject);
begin
 HideRed.Tag:=1-HideRed.Tag;
 if HideRed.Tag=1 then PlotPanel1.HideLayer(0)
                  else PlotPanel1.UnHideLayer(0);
end;

procedure TForm1.HideGreenClick(Sender: TObject);
begin
  Hidegreen.Tag:=1-HideGreen.Tag;
 if HideGreen.Tag=1 then PlotPanel1.HideLayer(1)
                  else PlotPanel1.UnHideLayer(1);
end;

procedure TForm1.PlotPanel1MouseMove(Sender: TObject; Shift: TShiftState;
  X, Y: Integer);
var
  WX, WY : Extended;
  Test : Boolean;
begin
  Test:=PlotPanel1.ConvertS2W(X,Y,WX,WY);
  if Test=True then TestLabel.Caption:='Inside is True'
               else TestLabel.Caption:='Inside is False' ;
  XLabel.Caption:='X = '+FloatToStr(WX);
  YLabel.Caption:='Y = '+FloatToStr(WY);
end;

procedure TForm1.FormMouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
  TestLabel.Caption:='Inside is ----' ;
  XLabel.Caption:='X = ----';
  YLabel.Caption:='Y = ----';
end;

procedure TForm1.ZoomInClick(Sender: TObject);
var
  XMid, YMid, Xn, Yn : Double;
  Zoomfactor : Double;
begin
  Zoomfactor:=1.1;
  With PlotPanel1 do
   begin
    XMid:=(XMax+XMin)/2;
    YMid:=(YMax+Ymin)/2;
    Xn:=(Xmid-Xmin)/Zoomfactor;
    Yn:=(YMid-Ymin)/Zoomfactor;
    Freeze(True);
    XMin:=Xmid-Xn;
    XMax:=XMid+Xn;
    YMin:=Ymid-Yn;
    YMax:=YMid+Yn;
    If (Xmax-Xmin)/XMarksInterval<5
       Then XMarksInterval:=XmarksInterval/2;
    If (Ymax-Ymin)/YMarksInterval<5
       Then YMarksInterval:=YmarksInterval/2;
    Freeze(False);
   end;
end;

procedure TForm1.ZoomOutClick(Sender: TObject);
var
  XMid, YMid, Xn, Yn : Double;
  Zoomfactor : Double;
begin
  Zoomfactor:=1.1;
  With PlotPanel1 do
   begin
    XMid:=(XMax+XMin)/2;
    YMid:=(YMax+Ymin)/2;
    Xn:=(Xmid-Xmin)*Zoomfactor;
    Yn:=(YMid-Ymin)*Zoomfactor;
    Freeze(True);
    XMin:=Xmid-Xn;
    XMax:=XMid+Xn;
    YMin:=Ymid-Yn;
    YMax:=YMid+Yn;
    Freeze(False);
    If (Xmax-Xmin)/XMarksInterval>20
       Then XMarksInterval:=XmarksInterval*2;
    If (Ymax-Ymin)/YMarksInterval>20
       Then YMarksInterval:=YmarksInterval*2;
   end;
end;

end.
